# frozen_string_literal: true

require 'cht-chaphql'
require 'cht-chaphql/graphql_formatters'

MDR_FMTRS =
  YAML.load_file(File.join(__dir__, '../helpers/formatters.yml'))

# module for mdr
module ChtApitestMdr
  include Chaphql
  include Chaphql::GraphQLHelpers

  # module for your shortcuts
  module MdrHelpers
    # insertion point for shortcuts

    def async_preview_flex_report(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('async_preview_flex_report')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { chunkedResult: args[:chunkedResult], queryInput: { dataGranularity: args[:dataGranularity], limit: args[:limit], needBackLinkingForTags: args[:needBackLinkingForTags], sqlStatement: args[:sqlStatement], timeRange: { excludeCurrent: args[:excludeCurrent], from: args[:from], last: args[:last], to: args[:to] } } }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def create_flex_report(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('create_flex_report')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { input: { chart: { columns: args[:columns], defaultChartType: args[:defaultChartType], defaultX: args[:defaultX], defaultY: args[:defaultY], defaultYs: args[:defaultYs], defaultZ: args[:defaultZ], x: args[:x], y: args[:y], z: args[:z] }, description: args[:description], name: args[:name], notification: { otherEmailIds: args[:otherEmailIds], sendUserEmail: args[:sendUserEmail] }, query: { dataGranularity: args[:dataGranularity], limit: args[:limit], needBackLinkingForTags: args[:needBackLinkingForTags], sqlStatement: args[:sqlStatement], timeRange: { excludeCurrent: args[:excludeCurrent], from: args[:from], last: args[:last], to: args[:to] } }, sourceReportOrTemplateId: args[:sourceReportOrTemplateId] } }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def update_flex_report(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('update_flex_report')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { id: args[:id], input: { chart: { columns: args[:columns], defaultChartType: args[:defaultChartType], defaultX: args[:defaultX], defaultY: args[:defaultY], defaultYs: args[:defaultYs], defaultZ: args[:defaultZ], x: args[:x], y: args[:y], z: args[:z] }, description: args[:description], name: args[:name], notification: { otherEmailIds: args[:otherEmailIds], sendUserEmail: args[:sendUserEmail] }, query: { dataGranularity: args[:dataGranularity], limit: args[:limit], needBackLinkingForTags: args[:needBackLinkingForTags], sqlStatement: args[:sqlStatement], timeRange: { excludeCurrent: args[:excludeCurrent], from: args[:from], last: args[:last], to: args[:to] } }, sourceReportOrTemplateId: args[:sourceReportOrTemplateId] } }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def archive_flex_report(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('archive_flex_report')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { id: args[:id] }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def delete(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('delete')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { id: args[:id] }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def create_flex_report_template(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('create_flex_report_template')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { input: { chart: { columns: args[:columns], defaultChartType: args[:defaultChartType], defaultX: args[:defaultX], defaultY: args[:defaultY], defaultYs: args[:defaultYs], defaultZ: args[:defaultZ], x: args[:x], y: args[:y], z: args[:z] }, description: args[:description], name: args[:name], query: { dataGranularity: args[:dataGranularity], limit: args[:limit], needBackLinkingForTags: args[:needBackLinkingForTags], sqlStatement: args[:sqlStatement], timeRange: { excludeCurrent: args[:excludeCurrent], from: args[:from], last: args[:last], to: args[:to] } } } }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def update_flex_report_template(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('update_flex_report_template')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { id: args[:id], input: { chart: { columns: args[:columns], defaultChartType: args[:defaultChartType], defaultX: args[:defaultX], defaultY: args[:defaultY], defaultYs: args[:defaultYs], defaultZ: args[:defaultZ], x: args[:x], y: args[:y], z: args[:z] }, description: args[:description], name: args[:name], query: { dataGranularity: args[:dataGranularity], limit: args[:limit], needBackLinkingForTags: args[:needBackLinkingForTags], sqlStatement: args[:sqlStatement], timeRange: { excludeCurrent: args[:excludeCurrent], from: args[:from], last: args[:last], to: args[:to] } } } }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def delete_flex_report_template(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('delete_flex_report_template')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { id: args[:id] }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def import_flex_report_template_registry(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('import_flex_report_template_registry')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { s3Location: args[:s3Location] }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def execute_flex_report_query(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('execute_flex_report_query')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { pageSize: args[:pageSize], queryInput: { dataGranularity: args[:dataGranularity], limit: args[:limit], needBackLinkingForTags: args[:needBackLinkingForTags], sqlStatement: args[:sqlStatement], timeRange: { excludeCurrent: args[:excludeCurrent], from: args[:from], last: args[:last], to: args[:to] } } }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def trigger_flex_report_execution(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('trigger_flex_report_execution')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { id: args[:id] }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def execute_flex_report_instantly(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('execute_flex_report_instantly')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { id: args[:id] }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def node(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('node')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables =
        graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def preview_flex_report(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('preview_flex_report')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { queryInput: { dataGranularity: args[:dataGranularity], limit: args[:limit], needBackLinkingForTags: args[:needBackLinkingForTags], sqlStatement: args[:sqlStatement], timeRange: { excludeCurrent: args[:excludeCurrent], from: args[:from], last: args[:last], to: args[:to] } } }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def preview_flex_report_json(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('preview_flex_report_json')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { queryInput: { dataGranularity: args[:dataGranularity], limit: args[:limit], needBackLinkingForTags: args[:needBackLinkingForTags], sqlStatement: args[:sqlStatement], timeRange: { excludeCurrent: args[:excludeCurrent], from: args[:from], last: args[:last], to: args[:to] } } }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def async_preview_flex_report_response_status(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('async_preview_flex_report_response_status')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { statusInput: { asyncPreviewId: args[:asyncPreviewId] } }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def flex_reports(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('flex_reports')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { dataset: args[:dataset] }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def data_source_metadata(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('data_source_metadata')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { dataset: args[:dataset], type: args[:type] }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def data_sources(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('data_sources')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = {  }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def flex_report_templates(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('flex_report_templates')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { dataset: args[:dataset], templateName: args[:templateName] }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def validate_flex_report_template_registry(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('validate_flex_report_template_registry')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { s3Location: args[:s3Location] }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def get_flex_report_query_result(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('get_flex_report_query_result')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
                   auth_service: args[:auth_service]))
      data = format_request(sym, args)
      variables = { input: { page: args[:page] } }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def get_flex_report_bulk_query_result(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('get_flex_report_bulk_query_result')).to_sym
      headers = apitest_headers(
          args.merge(with_auth: true,
                     auth_service: auth_service))
      data = args[:body] || format_request(sym, args)
      variables = {"flexReportExecutionId"=>args[:flexReportExecutionId]}
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args) unless args[:body]
      json_body[:data][sym]
    end

    def execute_flex_report_bulk_query(args = {})
      args[:service] = MdrService.new
      sym = first_no_cap(camelize('execute_flex_report_bulk_query')).to_sym
      headers = apitest_headers(
          args.merge(with_auth: true,
                     auth_service: auth_service))
      data = args[:body] || format_request(sym, args)
      variables = {"queryInput"=>{"archivedAsOf"=>args[:archivedAsOf], "dataGranularity"=>args[:dataGranularity], "limit"=>args[:limit], "needBackLinkingForTags"=>args[:needBackLinkingForTags], "sqlStatement"=>args[:sqlStatement], "timeRange"=>args[:timeRange]}, "requestInfo"=>{"caller"=>args[:caller], "sourceType"=>args[:sourceType]}, "resultFormat"=>args[:resultFormat]}
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args) unless args[:body]
      json_body[:data][sym]
    end

    def regenerate_headers
      tokens = login_api(ENV['API_KEY'], service: auth_service)
      apitest_headers(with_auth: true, access_token: tokens[:access_token])
    end

    # end of shortcut insertion
  end

  # class for your service
  class MdrService < ChtNgService
    include RSpec::Matchers

    MDR_DEFAULTS = {
      name: 'Mdr',
      default_namespace: 'mdr',
      service_name: 'mdr',
      pr_parent: 'mdr',
      formatters: MDR_FMTRS['formatters'],
      checkers: MDR_FMTRS['checkers']
    }.freeze
    def initialize(args = {})
      super(args.merge(MDR_DEFAULTS))
    end
  end

  # class for api-proxy support of mdr service
  class ApiProxyMdr < ChtNgService
    include RSpec::Matchers

    API_PROXY_DEFAULTS = {
      name: 'ApiProxyMdr',
      default_namespace: 'api-proxy',
      service_name: 'api-proxy',
      pr_parent: 'api-proxy',
      formatters: MDR_FMTRS['formatters'],
      checkers: MDR_FMTRS['checkers']
    }.freeze
    def initialize(args = {})
      super(args.merge(API_PROXY_DEFAULTS))
    end
  end
end
